/**
 * vue-lang-router v2.0.0
 * (c) 2021 Radek Altof
 * Released under the MIT License.
 */

var LangRouter=function(t,e,a,r){"use strict";var n={name:"LocalizedLink",props:["to"],methods:{localizedTo:function(){if("string"==typeof this.to)return this.$localizePath(this.to);if("object"==typeof this.to&&"string"==typeof this.to.path){var t=JSON.parse(JSON.stringify(this.to));return t.path=this.$localizePath(t.path),t}return this.to}}};n.render=function(t,a,r,n,o,i){var l=e.resolveComponent("router-link");return e.openBlock(),e.createBlock(l,e.mergeProps({to:i.localizedTo()},t.$attrs),{default:e.withCtx((function(){return[e.renderSlot(t.$slots,"default")]})),_:3},16,["to"])},n.__file="src/plugin/components/LocalizedLink.vue";var o,i,l,s={name:"LanguageSwitcher",data:function(){return{currentUrl:this.url||this.$router.currentRoute.fullPath,links:[]}},props:["tag","active-class","url"],computed:{locale:function(){return this.$i18n.locale}},methods:{getTag:function(){return this.tag?this.tag:"div"},generateLinks:function(){var t=[],e=this.activeClass||"router-active-language",a=this._langRouter.translations;for(var r in a)a.hasOwnProperty(r)&&t.push({activeClass:r==this.locale?e:"",langIndex:r,langName:a[r].name||r,url:this.$localizePath(this.currentUrl,r)});this.links=t},detectRouterLinkClick:function(t){var e=this;if(t.defaultPrevented){for(var a=t.target;"a"!=a.tagName.toLowerCase();){if(a.classList.contains("router-language-switcher"))return;a=a.parentNode}if(a.pathname!=window.location.pathname){var r=this.$route.matched[this.$route.matched.length-1];r.aliasOf&&(r=r.aliasOf);var n=this.$router.resolve(a.pathname);if(0!=n.matched.length&&((n=n.matched[n.matched.length-1]).aliasOf&&(n=n.aliasOf),r==n)){var o=a.pathname+a.search+a.hash,i=Object.assign({},window.history.state,{current:o}),l=a.pathname.split("/")[1];this._langRouter.loadLanguage(l).then((function(){window.history.replaceState(i,"",o),e._langRouter.forcedNewRoute.value=o}))}}}}},watch:{$route:function(t){this.currentUrl=this.url||t.fullPath,this.generateLinks()},locale:function(){void 0!==this.currentUrl&&this.generateLinks()}},mounted:function(){var t=this;void 0!==this.currentUrl&&this.generateLinks(),e.watch(this._langRouter.forcedNewRoute,(function(e){t.currentUrl=e,t.generateLinks()}))}};s.render=function(t,a,r,n,o,i){return e.openBlock(),e.createBlock(e.resolveDynamicComponent(i.getTag()),{class:"router-language-switcher",onClick:i.detectRouterLinkClick},{default:e.withCtx((function(){return[e.renderSlot(t.$slots,"default",{links:o.links})]})),_:3},8,["onClick"])},s.__file="src/plugin/components/LanguageSwitcher.vue";var u=!1,c=[];function h(t,e){console.error("LangRouter: "+t),void 0!==e&&console.error(e)}function f(t){u?h("Already installed."):(u=!0,t.config.globalProperties._langRouter={translations:i,loadLanguage:p,forcedNewRoute:e.ref("")},t.config.globalProperties.$localizePath=y,t.component("localized-link",n),t.component("language-switcher",s))}function g(e){return t.i18n.global.locale=e,document.querySelector("html").setAttribute("lang",e),localStorage.setItem("VueAppLanguage",e),e}function p(e){return c.includes(e)?Promise.resolve(g(e)):(i[e]&&"function"==typeof i[e].load||h('Unable to load translations for "'+e+'", "load" function is missing!'),i[e].load().then((function(a){return t.i18n.global.setLocaleMessage(e,a.default||a),c.push(e),g(e)})).catch((function(t){h('Failed to load "'+e+'" translation.',t)})))}function d(t,e,a){t.forEach((function(t){var r=m(t.path,e);a||(r="/"+e+("/"!=r.charAt(0)?"/":"")+r),t.alias?Array.isArray(t.alias)||(t.alias=[t.alias]):t.alias=[],t.path!=r&&-1==t.alias.indexOf(r)&&t.alias.push(r),t.children&&d(t.children,e,!0)}))}function v(t,e,a){var r=t.path.split("/")[1];if(!i[r]){var n=localStorage.getItem("VueAppLanguage");if(n&&i[n])r=n;else{var l=function(){function t(t){return t.split("-")[0].toLowerCase()}if(navigator.languages&&navigator.languages.length)return t(navigator.languages[0]||"");return t(navigator.language||navigator.browserLanguage||navigator.userLanguage||"")}();r=l&&i[l]?l:o}if(r!=o){var s=m(t.path,r);return s="/"+r+("/"!=s.charAt(0)?"/":"")+s,a({path:s,query:t.query,hash:t.hash})}}p(r).then((function(){return a()}))}function m(t,e,a,r){var n=t.split("/");if(a&&l[a]){if(e==a)return t;var o=l[a],i={};Object.keys(o).forEach((function(t){i[o[t]]=t}));for(var s=r.split("/"),u=0;u<n.length;u++){var c=n[u];":"!=s[u].charAt(0)&&(n[u]=i[c]||c)}}for(var h=0;h<n.length;h++){var f=n[h];":"!=f.charAt(0)&&(n[h]=l[e][f]||f)}return n.join("/")}function y(e,a){a&&l[a]||(a=t.i18n.global.locale);var r=e,n="";e.includes("?")?(r=e.split("?")[0],n="?"+e.split("?")[1]):e.includes("#")&&(r=e.split("#")[0],n="#"+e.split("#")[1]);var i=r.split("/"),s=!!l[i[1]]&&i[1],u=this.$route.path.split("/")[1];if(a==o&&!l[u]&&!s)return e;var c=!1;if(s){var f=this.$router.resolve(r);0!=f.matched.length?c="/"==(c=(c=f.matched[f.matched.length-1]).aliasOf?c.aliasOf.path:c.path).charAt(0)?c:"/"+c:h('Router could not resolve path "'+r+'". URL localization may not work as expected.'),i.splice(1,1),r=i.join("/")}var g=m(r,a,s,c||r);return(g="/"+a+("/"!=g.charAt(0)?"/":"")+g)+n}return t.createLangRouter=function(e,n){for(var s in function(e){e||h("Options missing.");var r;o=e.defaultLanguage,i=e.translations,l=e.localizedURLs||{},((r=Array.isArray(i))||"object"!=typeof i)&&h("options.translations should be an object, received "+(r?"array":typeof i)+" instead.");((r=Array.isArray(l))||"object"!=typeof l)&&h("options.localizedURLs should be an object, received "+(r?"array":typeof l)+" instead.");"string"!=typeof o&&h("options.defaultLanguage should be a string, received "+typeof o+" instead.");var n={};for(var s in i)if(i.hasOwnProperty(s)){var u=i[s].messages;"object"!=typeof u||Array.isArray(u)||(n[s]=i[s].messages,c.push(s))}t.i18n=a.createI18n({legacy:!0,locale:o,fallbackLocale:o,messages:n})}(e),i)i.hasOwnProperty(s)&&!l[s]&&(l[s]={});for(var u in l)l.hasOwnProperty(u)&&d(n.routes,u);var g=r.createRouter(n);g.beforeEach(v);var p=g.install;return g.install=function(t,e){p.call(this,t,e),f.call(this,t)},g},t.default=function(){return!0},Object.defineProperty(t,"__esModule",{value:!0}),t}({},Vue,VueI18n,VueRouter);
